package blatt03;

/**
 * Implementation of the Edit-Distance on Strings.
 * 
 * @author Nils.Hoffmann@CeBiTec.Uni-Bielefeld.DE
 */
public class EditDistance implements StringDistance {

    /**
     * Calculates the Edit-Distance with unit cost on Strings a and b.
     * @param a
     * @param b
     * @return
     */
    public double getDistance(String a, String b) {
        if(a.isEmpty() && !b.isEmpty()) {
            return b.length();
        }else if(!a.isEmpty() && b.isEmpty()) {
            return a.length();
        }
        int rows = a.length()+1;
        int cols = b.length()+1;
        int[][] d = new int[rows][cols];
        int diag,ins,del;
        //d[0][0] = 0 => arrays are initialized with 0 in java
        for(int i=0;i<rows;i++) {
            for(int j=0;j<cols;j++) {
                if(i>0 && j>0){//most common case
                    diag = d[i-1][j-1]+(a.charAt(i-1)==b.charAt(j-1)?0:1);
                    del = d[i-1][j]+1;//deletion
                    ins = d[i][j-1]+1;//insertion
                    d[i][j] = Math.min(diag,Math.min(ins,del));
                }else if(i==0 && j>0) {//column initialization
                    d[i][j] = j;//gap in column, insertion
                }else if(j==0 && i>0) {//row initialization
                    d[i][j] = i;//gap in row, deletion
                }else {//only once
                    d[i][j] = 0;
                }
            }
        }
        return d[rows-1][cols-1];
    }
}
